import { Models } from './models';
/** check if string is a valid pattern */
export declare function isValid(pattern: string): boolean;
export declare function check(url: string, pattern: string): boolean;
export declare function getModels(pattern: string): string[];
export declare function getRestPramsNames(pattern: string): string[];
export declare function containsModels(url: string, models: string[]): boolean;
export declare function stars(n: number): string;
export declare function getRestParams(url: string, pattern: string): Object;
export declare const regexisPath: RegExp;
export declare function interpolateParamsToUrl(params: Object, url: string): string;
/**
 * Get query params from url, like 'ex' in /api/books?ex=value
*/
export declare function decodeUrl(url: string): Object;
/**
 * Create query params string for url
 *
 * @export
 * @param {UrlParams[]} params
 * @returns {string}
 */
export declare function getParamsUrl(params: Models.UrlParams[], doNotSerialize?: boolean): string;
export declare function prepareUrlOldWay(params?: TemplateStringsArray): string;
